

gokakyuHandler = {
	shellNum = 1,
	shells = {},
	defaultShell = {active = false, strength = 50.5, maxDist = 70000.5, maxMass = 1500000}, --1500 maxmass
}

muzzleflash = LoadSprite("gfx/glare.png")

function init()
	RegisterTool("kiblast", "KiBlast", "MOD/vox/gokakyu.vox")
	SetBool("game.tool.kiblast.enabled", true)
	SetFloat("game.tool.kiblast.ammo", 101)
	
	ballgravity = Vec(0, 0, 0)
	hadoukendamage = 50 --1.5
	velocity = 1.6	--0.2
	strength = 100
	ExplFlash = 0
	ToolReady = 0
	coolDown = 0
	Flashtimer = 0
	expltimer = 0
	
	shakex = 0
    shakey = 0
    shakez = 0
	
	for i=1, 100 do
		gokakyuHandler.shells[i] = deepcopy(gokakyuHandler.defaultShell)
	end

	gokakyusound4 = LoadSound("snd/KiBlastExplosion.ogg")
	gokakyusound5 = LoadSound("snd/KiBlastExplosion2.ogg")
	gokakyusound7 = LoadSound("snd/KiBlastExplosion4.ogg")
	gokakyusound8 = LoadSound("snd/KiBlastExplosion5.ogg")
	

	gokakyuSprite2 = LoadSprite("img/YellowKiBlast.png") --gokakyuball2
	gokakyuSprite3 = LoadSprite("img/Glow.png") --gokakyuball2
end

function canShoot()
	local vehicle = GetPlayerVehicle()
	if vehicle ~= 0 then
		local driverPos = GetVehicleDriverPos(vehicle)
		local t = GetVehicleTransform(vehicle)
		local worldPos = TransformToParentPoint(t, driverPos)
		local cameraPos = GetCameraTransform().pos
		local length = VecLength(VecSub(cameraPos, worldPos))

		if length < 1 then
			return true
		else
			return false
		end
	end
	return true
end

function deepcopy(orig)
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in next, orig, nil do
            copy[deepcopy(orig_key)] = deepcopy(orig_value)
        end
        setmetatable(copy, deepcopy(getmetatable(orig)))
    else
        copy = orig
    end
    return copy
end

function GetAimPos()
	local ct = GetCameraTransform()
	local forwardPos = TransformToParentPoint(ct, Vec(0, 0, -100))
    local direction = VecSub(forwardPos, ct.pos)
    local distance = VecLength(direction)
	local direction = VecNormalize(direction)
	local hit, hitDistance = QueryRaycast(ct.pos, direction, distance)
	if hit then
		forwardPos = TransformToParentPoint(ct, Vec(0, 0, -hitDistance))
		distance = hitDistance
	end
	return forwardPos, hit, distance
end

function rnd(mi, ma)
	return math.random(0, 1000)/1000*(ma-mi)+mi
end

function rndVec(t)
	return Vec(rnd(-t, t), rnd(-t, t), rnd(-t, t))
end

function RandomVector(magnitude)
    local x = Random()
    local y = Random()
    local z = Random()
    return Vec((x - 0.5) * 2 * magnitude, (y - 0.5) * 2 * magnitude, (z - 0.5) * 2 * magnitude)
end

function Random()
    return math.random(0, 1000) / 1000
end

function Shoot()
	Flashtimer = 0
	aimpos, hit, distance = GetAimPos()
	local direction = VecSub(aimpos, toolPos)
		local v = VecAdd(Vec(-8, 8, 0), rndVec(rnd(8*0.5, 8*1.5))) --VecAdd(Vec(0, 15, 0 ), rndVec(rnd(15*0.5, 15*1.5)))
		local v1 = VecAdd(Vec(8, 8, 0), rndVec(rnd(8*0.5, 8*1.5))) --VecAdd(Vec(0, 15, 0 ), rndVec(rnd(15*0.5, 15*1.5)))
		local life = rnd(0.75, 0.85)
		life = life*life * 0.15
		ParticleReset()
		ParticleAlpha(1, 0)
		ParticleEmissive(1.5, 0.5, "easeout")
		ParticleGravity(-10)
		ParticleRadius(0.15, 0, "easein")
		ParticleColor(1, 1, 0.4)
		ParticleTile(0)
		SpawnParticle(toolPos, v, life)
		SpawnParticle(toolPos, v, life)
		SpawnParticle(toolPos, v, life)
		SpawnParticle(toolPos, v, life)
		SpawnParticle(toolPos, v, life)
		SpawnParticle(toolPos, v, life)
		SpawnParticle(toolPos, v, life)
		SpawnParticle(toolPos, v1, life)
		SpawnParticle(toolPos, v1, life)
		SpawnParticle(toolPos, v1, life)
		SpawnParticle(toolPos, v1, life)
		SpawnParticle(toolPos, v1, life)
		SpawnParticle(toolPos, v1, life)
		SpawnParticle(toolPos, v1, life)
	
	gokakyuHandler.shells[gokakyuHandler.shellNum] = deepcopy(gokakyuHandler.defaultShell)
	loadedShell = gokakyuHandler.shells[gokakyuHandler.shellNum] 
	loadedShell.active = true
	loadedShell.pos = toolPos
	loadedShell.counter = 1
	loadedShell.predictedBulletVelocity = VecScale(direction, velocity*(100/distance))
	gokakyuHandler.shellNum = (gokakyuHandler.shellNum%#gokakyuHandler.shells) +1
end

function rnd1(mi, ma)
	return math.random(0.25, 3)/3*(ma-mi)+mi
end

function gokakyuOperations(projectile)
	projectile.predictedBulletVelocity = VecAdd(projectile.predictedBulletVelocity, (VecScale(ballgravity, GetTimeStep())))
	local point2 = VecAdd(projectile.pos, VecScale(projectile.predictedBulletVelocity, GetTimeStep()))
	local dir = VecNormalize(VecSub(point2, projectile.pos))
	local hit, dist, normal, shape = QueryRaycast(projectile.pos, dir, VecLength(VecSub(point2, projectile.pos)))
	
		local dir = VecNormalize(VecSub(point2, projectile.pos))
		local hitPos5 = VecAdd(projectile.pos, VecScale(dir, dist))

		local hitPosTrans = Transform(hitPos5,GetCameraTransform().rot)

	if hit then
	expltimer = 0
		DrawBodyOutline(shape, 0, 1, 0, 1)
		ExplFlash = math.random(15,30)
		hitPos = VecAdd(projectile.pos, VecScale(VecNormalize(VecSub(point2, projectile.pos)), dist))
		projectile.active = false --false
		Paint(hitPos, 3, "explosion")
		
		MakeHole(hitPos, 1, 0.9, 0.8)
		MakeHole(hitPos, 2.5, 2.25, 2) --3 --2.75, 2.25, 1.5 --3.5, 2.65, 1.9
		
		s = math.random(0.5, 0.8) --0.5, 0.8
		lol = math.random(1, 100)
		lolol = math.random(1, 100)
		lol1 = math.random(1, 100)
		lolol1 = math.random(1, 100)

			local acd = math.random(-750, 750)/1000
			local acd1 = math.random(-650, 850)/1000
			local ac = math.random(-750, 750)/1000
			local ac1 = math.random(-650, 850)/1000
			local dirUp    = TransformToParentVec(hitPosTrans,Vec( ac, 1, 0))
			local dirDown  = TransformToParentVec(hitPosTrans,Vec( ac1,-1, 0))
			local dirLeft  = TransformToParentVec(hitPosTrans,Vec(-1, acd, 0))
			local dirRight = TransformToParentVec(hitPosTrans,Vec( 1, acd1, 0))
			local dirBack  = TransformToParentVec(hitPosTrans,Vec( 0, 0, 1))
			local dirFront = TransformToParentVec(hitPosTrans,Vec( 0, 0,-1))

			local holeDist = math.random(1250, 1350)/1000 -- 500, 1000<means 0.5, 1
			
			pickmakehole = math.random(1, 2)
			if pickmakehole == 1 then
			
			ss = math.random(1700, 2000)/1000
			ss1 = math.random(1550, 1750)/1000
			ss2 = math.random(1400, 1500)/1000
			--LEFTNRIGHT
			local holePosLeft   = VecAdd(hitPos5, VecScale(dirLeft, holeDist))
			if expltimer > 0.035 then
			MakeHole(holePosLeft,ss,ss1,ss2)
			end
			elseif pickmakehole == 2 then
			
			hh = math.random(1700, 2000)/1000
			hh1 = math.random(1550, 1750)/1000
			hh2 = math.random(1400, 1500)/1000

			local holePosRight = VecAdd(hitPos5, VecScale(dirRight, holeDist))
			if expltimer > 0.055 then
			MakeHole(holePosRight,hh,hh1,hh2)
			end
			end
			
			--UPNDOWN
			pickmakehole1 = math.random(1, 2)
			if pickmakehole1 == 1 then
			
			sf = math.random(1700, 2000)/1000
			sf1 = math.random(1550, 1750)/1000
			sf2 = math.random(1400, 1500)/1000
			-- up hole
			local holePosUp = VecAdd(hitPos5, VecScale(dirUp, holeDist))
			if expltimer > 0.045 then
			MakeHole(holePosUp,sf,sf1,sf2)
			end
			elseif pickmakehole1 == 2 then
			
			hj = math.random(1700, 2000)/1000
			hj1 = math.random(1550, 1750)/1000
			hj2 = math.random(1400, 1500)/1000
			-- down hole
			local holePosDown = VecAdd(hitPos5, VecScale(dirDown, holeDist))
			if expltimer > 0.025 then
			MakeHole(holePosDown,hj,hj1,hj2)
			end
			end
		
		if distance<25 then
			if lol<50 then
			ShakeCamera(0.6) 
			SetCameraDof(10, 30)
			PlaySound(gokakyusound4, hitPos, 1.6) --DebugPrint("hi2") --
			end
				if lol>50 then
				ShakeCamera(0.7) 
				PlaySound(gokakyusound5, hitPos, 1.3) --DebugPrint("hi1")
				end
					if lolol<50 then
					PlaySound(gokakyusound7, hitPos, 0.75) --DebugPrint("hi4") 
					end
						if lolol>50 then
						PlaySound(gokakyusound8, hitPos, 0.5) --DebugPrint("hi3") --the loud one
						end	
		end						
		if distance>25 then
			if lol1<50 then
			ShakeCamera(0.6) 
			PlaySound(gokakyusound4, hitPos, 3.725) --DebugPrint("hi2")
			end
				if lol1>50 then
				ShakeCamera(0.7) 
				PlaySound(gokakyusound5, hitPos, 3.75) --DebugPrint("hi1")
				end
					if lolol1<50 then
					PlaySound(gokakyusound7, hitPos, 3) --DebugPrint("hi4") 
					end
						if lolol1>50 then
						PlaySound(gokakyusound8, hitPos, 2.7) --DebugPrint("hi3")
						end	
		end					
			
			max = 5
			local objectbodies = QueryAabbBodies( VecAdd(hitPos, Vec(-max, -max, -max)), VecAdd(hitPos, Vec(max, max, max)))
            for i = 1, #objectbodies do
                local objectbodies2 = objectbodies[i]
                if IsBodyDynamic(objectbodies2) then
                  local bb, bbba = GetBodyBounds(objectbodies2)
                  local direction = VecSub(VecLerp(bb, bbba, 0.5), hitPos)
                  local distance = VecLength(direction)
                  direction = VecScale(direction, 1 / distance)
                  if distance < max and IsBodyVisible(objectbodies2, max * 100)then --max * 100
                    local distScale = 1 - math.min(distance / max, 0.9)
                    local vel = GetBodyVelocity(objectbodies2)
					--local voxelCount = GetShapeVoxelCount(objectbodies2)
					--DebugPrint(voxelCount)
					angVel = VecAdd(GetBodyAngularVelocity(objectbodies2), VecScale(direction, 2 * distScale))
					--if voxelCount < 200 then
                    vel = VecAdd(GetBodyVelocity(objectbodies2), VecScale(direction, 10 * distScale)) --50
                    SetBodyVelocity(objectbodies2, vel)
					--SetBodyAngularVelocity(objectbodies2, angVel)
					--end
					end
				  end
			   end	
				
				            --dir forward
			local t = GetPlayerCameraTransform()
			local dir = TransformToParentVec(t, Vec(0, 0.15, -1))
			local hitbody = GetShapeBody(shape)
			local mass = GetBodyMass(hitbody)
			local scale = math.sin(GetTime())*0.5 + 0.5
			--DebugPrint(mass)
			if mass > 50000 then
			end
			if mass < 50000 then
			ApplyBodyImpulse(hitbody,hitPos,VecScale(dir,mass*4))
			SetShapeEmissiveScale(hitbody, 550)
			end
			
		local e = Transform(Vec(), QuatAxisAngle(Vec(1, 0, 0), math.sin(3.0) * 3.0))
		SetPlayerCameraOffsetTransform(e)
		
		ParticleType("smoke")
		ParticleAlpha(1, 0)
		ParticleTile(0) --5
		ParticleRadius(0.9)--0.6
		ParticleColor(1,1,1)
		ParticleEmissive(0)
		SpawnParticle(hitPos, Vec(0, 0.05, 0), 1.8)
		SpawnParticle(hitPos, Vec(0, 0.05, 0), 0.3)
		SpawnParticle(hitPos, Vec(0, 0.2, 0), 1.2)
		ParticleEmissive(0)
		SpawnParticle(hitPos, Vec(0, 2, 0), 0.8)
		ParticleTile(5)
		ParticleEmissive(0)
		SpawnParticle(hitPos, Vec(0, 4, 0), 0.6)
		
		math.random()
		ParticleReset()
		local v = VecAdd(Vec(0, 8, 0 ), rndVec(rnd(12*0.5, 16*1.5)))
		ParticleAlpha(0.85, 0)
		ParticleRadius(0, 3)
		ParticleEmissive(0, 0)
		ParticleColor(0.8, 0.8, 0.8)
		ParticleTile(0)
		SpawnParticle(hitPos, v, 0.25)
		SpawnParticle(hitPos, v, 0.25)
		math.random()
		ParticleReset()
		local v = VecAdd(Vec(0, 4, 0 ), rndVec(rnd(8*0.5, 12*1.5)))
		ParticleAlpha(0.85, 0)
		ParticleRadius(0, 3)
		ParticleEmissive(0, 0)
		ParticleColor(0.8, 0.8, 0.8)
		ParticleTile(0)
		SpawnParticle(hitPos, v, 0.35)
		SpawnParticle(hitPos, v, 0.35)
		math.random()
		ParticleReset()
		local v = VecAdd(Vec(0, 8, 0 ), rndVec(rnd(12*0.5, 18*1.5)))
		ParticleAlpha(0.85, 0)
		ParticleRadius(0, 3)
		ParticleEmissive(0, 0)
		ParticleColor(0.8, 0.8, 0.8)
		ParticleTile(0)
		SpawnParticle(hitPos, v, 0.35)
		SpawnParticle(hitPos, v, 0.35)

	for i=1, 100 do
		local v = VecAdd(Vec(0, 4, 0 ), rndVec(rnd(8*0.5, 12*1.5))) --VecAdd(Vec(0, 15, 0 ), rndVec(rnd(15*0.5, 15*1.5)))
		local life = rnd(0, 1)
		life = life*life * 5
		ParticleReset()
		ParticleEmissive(5, 1, "easeout")
		ParticleGravity(-10)
		ParticleRadius(0.03, 0.0, "easein")
		ParticleColor(1, 0.4, 0.3)
		ParticleTile(4)
		SpawnParticle(hitPos, v, life)
	end
		l = math.random(0, 100)
		if l > 65 then
		for i=1, 10 do
			local v = VecAdd(Vec(0, 10, 0 ), rndVec(rnd(15*0.5, 20*1.5))) --VecAdd(Vec(0, 15, 0 ), rndVec(rnd(15*0.5, 15*1.5)))
			local life = rnd(1, 1.25)
			life = life*life * 0.35
			sh = math.random(1.5, 3)
			ParticleReset()
			ParticleStretch(sh)
			ParticleEmissive(5, 5, "easeout")
			ParticleGravity(-10)
			ParticleRadius(0.3, 0.0, "easein")
			ParticleColor(1, 1, 0.2)
			ParticleTile(4)
			SpawnParticle(hitPos, v, life)
			end
		end
		
	end

	ParticleTile(0) --5
	local val = math.random()
	if val < 0.333 then
	ParticleColor(1, 1, 0.2) --1,0.3,0 --1, 1, 1
	elseif val < 0.667 then
	ParticleColor(1, 1, 0.2) --1,0.2,0 --1, 1, 1
	else
	ParticleColor(1, 1, 0.2) --0,0,0 --1, 1, 1
	end
	ParticleRadius(0.15, 0)--0.6
	ParticleEmissive(25, 25)
	ParticleCollide(0)
	for i=1, 10 do
	SpawnParticle(projectile.pos, Vec(0, 0, 0), 0.12) --0.3 liftime --2 velocity 
	end
	ParticleRadius(0.3, 0)
	ParticleColor(1, 1, 0.2) --0,0,0 --2, 2, 0.1
	ParticleAlpha(0.2, 0.2)
	ParticleEmissive(2, 2)
	ParticleCollide(0)
	for i=1, 10 do
	SpawnParticle(projectile.pos, Vec(0, 0, 0), 0.12) --0.3 liftime --2 velocity 
	end
	
	local rot = QuatLookAt(projectile.pos, GetCameraTransform().pos)
	local transform = Transform(projectile.pos, rot)
	DrawSprite(gokakyuSprite3, transform, 0.5, 0.5, 1, 1, 1, 0.75, true, false) --2,2,1,1,1,0.75

	projectile.counter = projectile.counter + 1
    projectile.pos = point2
	
	PointLight(projectile.pos, 1, 1, 0.2, 5) --0.5, 0.5

	local t = GetPlayerCameraTransform()
	local dir = TransformToParentVec(t, Vec(0, 0, -1))
	local hitbody = GetShapeBody(shape)
	local mass = GetBodyMass(hitbody)
	if mass > 50000 then
	end
	if mass < 50000 then
	ApplyBodyImpulse(hitbody,hitPos,VecScale(dir,mass*-1))
	end
end

function rndVec(length)
	local v = VecNormalize(Vec(math.random(-100,100), math.random(-100,100), math.random(-100,100)))
	return VecScale(v, length)	
end

function tick(dt)

	if GetString("game.player.tool") == "kiblast" and GetPlayerVehicle() == 0 then
		SetBool("game.input.locktool", flycamenabled)
		firing = InputDown("usetool")
		if ToolReady < 1 then
			ToolReady = ToolReady + dt * 2
		end
		
		if ExplFlash > 0 then
		    local a = VecAdd (hitPos, Vec(0, 1, 0))
			local b = math.random(240, 300)
			PointLight(a, 1, 1, 0.2, ExplFlash*2)
			ExplFlash = ExplFlash - dt*b
		end
	end
	
	
	if GetString("game.player.tool") == "kiblast" and canShoot() then
	
			local b = GetToolBody()
			if b ~= 0 then
			local offset = Transform(Vec(0.4, -0.5, -0.48))-- 0.4, -0.5, -0.28 0.8, -1, -0.56
			SetToolTransform(offset)
			toolTrans = GetBodyTransform(b)
			toolPos = TransformToParentPoint(toolTrans, Vec(0.12, 0.2, -0.8)) -- 0.3, -0.45, -2.4 0.6, -0.9, -4.8
			
			if InputDown("lmb") then
			if GetString("game.player.tool") == "kiblast" and GetPlayerVehicle() == 0 then

            if InputDown("lmb") then
				cc = math.random(2,2.75)
				cv = math.random(4.5,5.5)
					local rnd = math.random()*3/4+1
						if Flashtimer > 0 and Flashtimer < 0.04 then
						DrawSprite(muzzleflash,{pos=toolPos,rot=GetCameraTransform().rot},cc*rnd,cv*rnd, 1,1,0.2, 1,0.3,1, 0.01,false, true)
						DrawSprite(muzzleflash,{pos=toolPos,rot=GetCameraTransform().rot},cc-1.25*rnd,cv-1.25*rnd, 1,1,1, 1,0.3,1, 0.01,false, true)
						end
				if Flashtimer > 0.04 then
				Flashtimer = 0
				end
                shakex = math.random(-0, 0)/120
                shakey = math.random(-0.5, 0.5)/120
                shakez = math.random(-25, 0)/175
            end
				
			local t = Transform()
			t.pos = Vec(0.45+shakex, -0.5+shakey, -0.50+shakez) --change the last three values to change vhere bullets originate left/right, up/down, forward,back
			---t.pos = Vec(0.5+shakex, -0.5+shakey, -0.50+shakez) --change the last three values to change vhere bullets originate left/right, up/down, forward,back
			t.rot = QuatEuler(-3, 0, 0)
                SetToolTransform(t)
	end
			if coolDown < 0 then
			local b = GetToolBody()
			local scale = math.sin(GetTimeStep())*15 + 0.5
			PointLight(toolPos, 1, 1, 0.2, 2)
			Shoot()
			coolDown = 0.09
			end
			end
		end
	end
	coolDown = coolDown - dt
	Flashtimer = Flashtimer + dt
	expltimer = expltimer + dt
	--DebugPrint(coolDown)
		
	
	for key, shell in ipairs(gokakyuHandler.shells) do
		if shell.active then
			gokakyuOperations(shell)
		end
	end
end